;----------------------------------------------------------------------------- 
	; values correct for 8Mhz Fosc, 
_bitRateLookup	clrf 	PCLATH
	addwf  	 PCL,F 
	retlw  	 .103    ; 0, 1200 low speed BRG
        	retlw  	 .207    ; 1, 2400 high speed BRG
        	retlw	   .51    ; 2, 9600 high speed BRG
        	retlw 	  .25     ; 3, 19200 high speed BRG
_cmdFuncEnd   	retlw 	  .12     ; 4, 38400 high speed BRG


	IF (HIGH $ != 0)
	error "Lookup table in zcode_cmdfuncs.inc not in program memory page 0"
	ENDIF


_command        bcf	flags, rxNewCmd
	decf	Data2,W ; data2 == 0x01
        	iorwf	Data3,W ; data3 == 0x00 
        	skpz            ; if result == zero process command 
        	return 


highestCmd equ     .7 	
	movlw   	~highestCmd 
        	addwf   	Data0,W 
        	skpnc   
        	return 
        	movfw 	Data0 
        	addwf   	PCL,F 
        	return    		; 0 Keep awake
        	goto    	_colActivate   	; 1 Transfer (in zcode_pwmcalc.inc)
        	goto    	_startSave	; 2 save to EEPROM (in zcode_eeprom.inc)
        	goto    	_setAddress   	; 3 set Address 
        	goto    	_setBitRate   	; 4 set Bit Rate 
        	goto	_shutDown	; 5 shutdown PWM output
	goto	_inactiveTO	; 6 inactivity timeout enable
	goto	_servoFlush	; 7 flush data if servo transfer received


_setAddress	btfsc   Data1,7 	; ignore if new address bit 7 is set
        	return 	
        	movfw   Data1 
        	movwf   eepromAddress 
               	return 


_setBitRate	movlw   ~.4 
        	addwf   Data1,W 
        	skpnc 
        	return 
	movfw   Data1
        	movwf   eepromBitRate 
        	return 





_shutDown	movf	Data1,F
	bnz	_shutUp
	bcf	INTCON, GIE
	bcf	INTCON, GIE

	movfw	LEDport
	iorlw	(1<<redLED | 1<<grnLED | 1<<bluLED)
	btfsc	activeDriveLevel
	andlw	~(1<<redLED | 1<<grnLED | 1<<bluLED)
	movwf	LEDport
	bsf	flags2,pwmShutdown
	return


_shutUp	bsf	INTCON, GIE
	bcf	flags2, pwmShutdown
	return

_inactiveTO	movf	Data1,F
	movwf	eepromInactive
	return

_servoFlush	bcf	flags, rxNewCol	; clear Colour ready flag
	return		; if servo transfer command
			; is addressed to this device.