;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; zcode_isr.inc
; dev690a
; 08/10/2007
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


_isr	movwf	Wisr	
	swapf	STATUS,W		
	clrf	STATUS	
	movwf	Sisr
	bcf	PIR1, TMR2IF	 ; reset TMR2IF
	btfsc	flags2, driveLevel ; test LED drive level input
	goto	_driveHigh

;-------------------------------------------
; Interrupt code for active low PWM outputs
;
_driveLow	incfsz	pwmCntr,F	
	goto	_lowPWM

	incf	pwmCntr,F	; fix PWM
	movfw	red	; reload PWM counters with colour PWM value.
	movwf	redPWM
	incfsz	red,W
	bsf	LEDport, redLED	
	movfw	grn	; reload PWM counters with colour PWM value.
	movwf	grnPWM
	incfsz	grn,W
	bsf	LEDport, grnLED
	movfw	blu	; reload PWM counters with colour PWM value.
	movwf	bluPWM
	incfsz	blu,W
	bsf	LEDport, bluLED	
	
_lowPWM	incf	redPWM,f	
	skpnz
	bcf	LEDport, redLED

	incf	grnPWM,f	
	skpnz
	bcf	LEDport, grnLED

	incf	bluPWM,f	
	skpnz
	bcf	LEDport, bluLED
	
	swapf	Sisr,W	
	movwf	STATUS	
	swapf	Wisr,F	
	swapf	Wisr,W	
	retfie

;-------------------------------------------
; Interrupt code for active high PWM outputs
;
_driveHigh	incfsz	pwmCntr,F	
	goto	_highPWM
	incf	pwmCntr,F	; fix PWM
	movfw	red	; reload PWM counters with colour PWM value.
	movwf	redPWM
	incfsz	red,W
	bcf	LEDport, redLED	
	movfw	grn	; reload PWM counters with colour PWM value.
	movwf	grnPWM
	incfsz	grn,W
	bcf	LEDport, grnLED
	movfw	blu	; reload PWM counters with colour PWM value.
	movwf	bluPWM
	incfsz	blu,W
	bcf	LEDport, bluLED	
	
	
_highPWM	incf	redPWM,f	
	skpnz
	bsf	LEDport, redLED

	incf	grnPWM,f	
	skpnz
	bsf	LEDport, grnLED

	incf	bluPWM,f	
	skpnz
	bsf	LEDport, bluLED
	
	swapf	Sisr,W	
	movwf	STATUS	
	swapf	Wisr,F	
	swapf	Wisr,W
	retfie		;29 instructions (14.5uS) )total interrupt inc call and return
			;36 instructions (18uS) with PWM reload

			; 38400bps bit period = 26.04uS
			; 8N1 frame (10bits) = 260.41uS
			; 260uS / 50uS = 5.2 interrupts per frame
		